# coding: utf-8

# flake8: noqa

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

# import apis into sdk package
from cythereal_dashboard.api.binaries_api import BinariesApi
from cythereal_dashboard.api.campaigns_api import CampaignsApi
from cythereal_dashboard.api.charts_api import ChartsApi
from cythereal_dashboard.api.dashboard_api import DashboardApi
from cythereal_dashboard.api.emails_api import EmailsApi
from cythereal_dashboard.api.files_api import FilesApi
from cythereal_dashboard.api.reports_api import ReportsApi
from cythereal_dashboard.api.signatures_api import SignaturesApi
from cythereal_dashboard.api.tables_api import TablesApi
from cythereal_dashboard.api.update_api import UpdateApi
from cythereal_dashboard.api.workspaces_api import WorkspacesApi

# import ApiClient
from cythereal_dashboard.api_client import ApiClient
from cythereal_dashboard.configuration import Configuration
# import models into sdk package
from cythereal_dashboard.models.analysis import Analysis
from cythereal_dashboard.models.api_response import ApiResponse
from cythereal_dashboard.models.archive_report import ArchiveReport
from cythereal_dashboard.models.av_names import AvNames
from cythereal_dashboard.models.binary_graph_list import BinaryGraphList
from cythereal_dashboard.models.binary_graph_model import BinaryGraphModel
from cythereal_dashboard.models.binary_list import BinaryList
from cythereal_dashboard.models.binary_model import BinaryModel
from cythereal_dashboard.models.binary_table_list import BinaryTableList
from cythereal_dashboard.models.binary_table_model import BinaryTableModel
from cythereal_dashboard.models.binary_table_model_analysis import BinaryTableModelAnalysis
from cythereal_dashboard.models.binary_table_model_labels import BinaryTableModelLabels
from cythereal_dashboard.models.campaign_graph_list import CampaignGraphList
from cythereal_dashboard.models.campaign_graph_model import CampaignGraphModel
from cythereal_dashboard.models.campaign_list import CampaignList
from cythereal_dashboard.models.campaign_map_list import CampaignMapList
from cythereal_dashboard.models.campaign_map_model import CampaignMapModel
from cythereal_dashboard.models.campaign_map_model_children import CampaignMapModelChildren
from cythereal_dashboard.models.campaign_model import CampaignModel
from cythereal_dashboard.models.categories import Categories
from cythereal_dashboard.models.categories_direct import CategoriesDirect
from cythereal_dashboard.models.categories_inferred import CategoriesInferred
from cythereal_dashboard.models.category import Category
from cythereal_dashboard.models.child_info import ChildInfo
from cythereal_dashboard.models.collection_model import CollectionModel
from cythereal_dashboard.models.color import Color
from cythereal_dashboard.models.detection_stats import DetectionStats
from cythereal_dashboard.models.email_object import EmailObject
from cythereal_dashboard.models.email_object_email_children import EmailObjectEmailChildren
from cythereal_dashboard.models.email_object_file_children import EmailObjectFileChildren
from cythereal_dashboard.models.email_object_ioc_objects import EmailObjectIocObjects
from cythereal_dashboard.models.email_threats_list import EmailThreatsList
from cythereal_dashboard.models.emails_list import EmailsList
from cythereal_dashboard.models.emails_list_inner import EmailsListInner
from cythereal_dashboard.models.emails_list_inner_descendants import EmailsListInnerDescendants
from cythereal_dashboard.models.emails_response_data import EmailsResponseData
from cythereal_dashboard.models.evasiveness import Evasiveness
from cythereal_dashboard.models.file_added import FileAdded
from cythereal_dashboard.models.file_info import FileInfo
from cythereal_dashboard.models.file_object import FileObject
from cythereal_dashboard.models.file_status import FileStatus
from cythereal_dashboard.models.file_upload_response_data import FileUploadResponseData
from cythereal_dashboard.models.filenames import Filenames
from cythereal_dashboard.models.files_list import FilesList
from cythereal_dashboard.models.filetype import Filetype
from cythereal_dashboard.models.info_counts_response_data import InfoCountsResponseData
from cythereal_dashboard.models.info_ids_response_data import InfoIdsResponseData
from cythereal_dashboard.models.inline_response409 import InlineResponse409
from cythereal_dashboard.models.is_group import IsGroup
from cythereal_dashboard.models.is_owned import IsOwned
from cythereal_dashboard.models.is_public import IsPublic
from cythereal_dashboard.models.is_updating_response_data import IsUpdatingResponseData
from cythereal_dashboard.models.is_user import IsUser
from cythereal_dashboard.models.labels import Labels
from cythereal_dashboard.models.labels_inner import LabelsInner
from cythereal_dashboard.models.magic_labels import MagicLabels
from cythereal_dashboard.models.magic_matches import MagicMatches
from cythereal_dashboard.models.magic_matches_match_subtypes import MagicMatchesMatchSubtypes
from cythereal_dashboard.models.magic_matches_matches import MagicMatchesMatches
from cythereal_dashboard.models.magic_report import MagicReport
from cythereal_dashboard.models.magic_yara_response_data import MagicYaraResponseData
from cythereal_dashboard.models.md5 import Md5
from cythereal_dashboard.models.name_with_collection import NameWithCollection
from cythereal_dashboard.models.name_with_color import NameWithColor
from cythereal_dashboard.models.name_with_hash import NameWithHash
from cythereal_dashboard.models.name_with_tags import NameWithTags
from cythereal_dashboard.models.names import Names
from cythereal_dashboard.models.num_matches import NumMatches
from cythereal_dashboard.models.object_class import ObjectClass
from cythereal_dashboard.models.procedure_info_list import ProcedureInfoList
from cythereal_dashboard.models.procedure_info_list_inner import ProcedureInfoListInner
from cythereal_dashboard.models.procedure_info_list_inner_blocks import ProcedureInfoListInnerBlocks
from cythereal_dashboard.models.procedure_report_response_data import ProcedureReportResponseData
from cythereal_dashboard.models.procedure_signature import ProcedureSignature
from cythereal_dashboard.models.procedure_signatures import ProcedureSignatures
from cythereal_dashboard.models.sha1 import Sha1
from cythereal_dashboard.models.sha256 import Sha256
from cythereal_dashboard.models.sha512 import Sha512
from cythereal_dashboard.models.shortened_file_object import ShortenedFileObject
from cythereal_dashboard.models.size import Size
from cythereal_dashboard.models.status import Status
from cythereal_dashboard.models.tag_model import TagModel
from cythereal_dashboard.models.tags import Tags
from cythereal_dashboard.models.timestamp import Timestamp
from cythereal_dashboard.models.tokens import Tokens
from cythereal_dashboard.models.workspace_list import WorkspaceList
from cythereal_dashboard.models.workspace_model import WorkspaceModel
from cythereal_dashboard.models.yara_id import YaraId
from cythereal_dashboard.models.yara_rule import YaraRule
from cythereal_dashboard.models.error_response import ErrorResponse
from cythereal_dashboard.models.success_response import SuccessResponse
from cythereal_dashboard.models.archive_report_response import ArchiveReportResponse
from cythereal_dashboard.models.binary import Binary
from cythereal_dashboard.models.binary_graph_list_response import BinaryGraphListResponse
from cythereal_dashboard.models.binary_list_response import BinaryListResponse
from cythereal_dashboard.models.binary_table_list_response import BinaryTableListResponse
from cythereal_dashboard.models.campaign import Campaign
from cythereal_dashboard.models.campaign_graph_list_response import CampaignGraphListResponse
from cythereal_dashboard.models.campaign_list_response import CampaignListResponse
from cythereal_dashboard.models.campaign_map_list_response import CampaignMapListResponse
from cythereal_dashboard.models.campaign_not_found import CampaignNotFound
from cythereal_dashboard.models.collection_response import CollectionResponse
from cythereal_dashboard.models.email_response import EmailResponse
from cythereal_dashboard.models.email_threats_response import EmailThreatsResponse
from cythereal_dashboard.models.emails_response import EmailsResponse
from cythereal_dashboard.models.file_details_response import FileDetailsResponse
from cythereal_dashboard.models.file_info_response import FileInfoResponse
from cythereal_dashboard.models.file_status_response import FileStatusResponse
from cythereal_dashboard.models.file_upload_response import FileUploadResponse
from cythereal_dashboard.models.files_added_response import FilesAddedResponse
from cythereal_dashboard.models.info_counts_response import InfoCountsResponse
from cythereal_dashboard.models.info_ids_response import InfoIdsResponse
from cythereal_dashboard.models.invalid_api_key import InvalidApiKey
from cythereal_dashboard.models.is_updating_response import IsUpdatingResponse
from cythereal_dashboard.models.magic_labels_response import MagicLabelsResponse
from cythereal_dashboard.models.magic_matches_response import MagicMatchesResponse
from cythereal_dashboard.models.magic_report_response import MagicReportResponse
from cythereal_dashboard.models.magic_yara_response import MagicYaraResponse
from cythereal_dashboard.models.missing_parameter import MissingParameter
from cythereal_dashboard.models.object_already_exists import ObjectAlreadyExists
from cythereal_dashboard.models.object_not_found import ObjectNotFound
from cythereal_dashboard.models.owned_files_list_response import OwnedFilesListResponse
from cythereal_dashboard.models.procedure_report_response import ProcedureReportResponse
from cythereal_dashboard.models.procedure_signatures_response import ProcedureSignaturesResponse
from cythereal_dashboard.models.unauthorized_api_key import UnauthorizedApiKey
from cythereal_dashboard.models.update_account_response import UpdateAccountResponse
from cythereal_dashboard.models.workspace_created_response import WorkspaceCreatedResponse
from cythereal_dashboard.models.workspace_list_response import WorkspaceListResponse
from cythereal_dashboard.models.workspace_response import WorkspaceResponse
