# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ProcedureInfoListInner(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sha1': 'Sha1',
        'sha256': 'Sha256',
        'sha512': 'Sha512',
        'md5': 'Md5',
        'object_class': 'ObjectClass',
        'unix_filetype': 'Filetype',
        'upload_date': 'Timestamp',
        'filenames': 'Filenames',
        'tags': 'Tags',
        'status': 'Status',
        'analysis': 'Analysis',
        'is_public': 'IsPublic',
        'is_owned': 'IsOwned',
        'tokens': 'Tokens',
        'av_names': 'AvNames',
        'detection_stats': 'DetectionStats',
        'labels': 'Labels',
        'start_ea': 'str',
        'end_ea': 'str',
        'procedure_name': 'str',
        'procedure_segment': 'str',
        'strings': 'list[str]',
        'api_calls': 'list[str]',
        'blocks': 'ProcedureInfoListInnerBlocks',
        'block_count': 'int',
        'code_count': 'int'
    }

    attribute_map = {
        'sha1': 'sha1',
        'sha256': 'sha256',
        'sha512': 'sha512',
        'md5': 'md5',
        'object_class': 'object_class',
        'unix_filetype': 'unix_filetype',
        'upload_date': 'upload_date',
        'filenames': 'filenames',
        'tags': 'tags',
        'status': 'status',
        'analysis': 'analysis',
        'is_public': 'is_public',
        'is_owned': 'is_owned',
        'tokens': 'tokens',
        'av_names': 'av_names',
        'detection_stats': 'detection_stats',
        'labels': 'labels',
        'start_ea': 'startEA',
        'end_ea': 'endEA',
        'procedure_name': 'procedure_name',
        'procedure_segment': 'procedure_segment',
        'strings': 'strings',
        'api_calls': 'api_calls',
        'blocks': 'blocks',
        'block_count': 'block_count',
        'code_count': 'code_count'
    }

    def __init__(self, sha1=None, sha256=None, sha512=None, md5=None, object_class=None, unix_filetype=None, upload_date=None, filenames=None, tags=None, status=None, analysis=None, is_public=None, is_owned=None, tokens=None, av_names=None, detection_stats=None, labels=None, start_ea=None, end_ea=None, procedure_name=None, procedure_segment=None, strings=None, api_calls=None, blocks=None, block_count=None, code_count=None):  # noqa: E501
        """ProcedureInfoListInner - a model defined in Swagger"""  # noqa: E501

        self._sha1 = None
        self._sha256 = None
        self._sha512 = None
        self._md5 = None
        self._object_class = None
        self._unix_filetype = None
        self._upload_date = None
        self._filenames = None
        self._tags = None
        self._status = None
        self._analysis = None
        self._is_public = None
        self._is_owned = None
        self._tokens = None
        self._av_names = None
        self._detection_stats = None
        self._labels = None
        self._start_ea = None
        self._end_ea = None
        self._procedure_name = None
        self._procedure_segment = None
        self._strings = None
        self._api_calls = None
        self._blocks = None
        self._block_count = None
        self._code_count = None
        self.discriminator = None

        if sha1 is not None:
            self.sha1 = sha1
        if sha256 is not None:
            self.sha256 = sha256
        if sha512 is not None:
            self.sha512 = sha512
        if md5 is not None:
            self.md5 = md5
        if object_class is not None:
            self.object_class = object_class
        if unix_filetype is not None:
            self.unix_filetype = unix_filetype
        if upload_date is not None:
            self.upload_date = upload_date
        if filenames is not None:
            self.filenames = filenames
        if tags is not None:
            self.tags = tags
        if status is not None:
            self.status = status
        if analysis is not None:
            self.analysis = analysis
        if is_public is not None:
            self.is_public = is_public
        if is_owned is not None:
            self.is_owned = is_owned
        if tokens is not None:
            self.tokens = tokens
        if av_names is not None:
            self.av_names = av_names
        if detection_stats is not None:
            self.detection_stats = detection_stats
        if labels is not None:
            self.labels = labels
        if start_ea is not None:
            self.start_ea = start_ea
        if end_ea is not None:
            self.end_ea = end_ea
        if procedure_name is not None:
            self.procedure_name = procedure_name
        if procedure_segment is not None:
            self.procedure_segment = procedure_segment
        if strings is not None:
            self.strings = strings
        if api_calls is not None:
            self.api_calls = api_calls
        if blocks is not None:
            self.blocks = blocks
        if block_count is not None:
            self.block_count = block_count
        if code_count is not None:
            self.code_count = code_count

    @property
    def sha1(self):
        """Gets the sha1 of this ProcedureInfoListInner.  # noqa: E501


        :return: The sha1 of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Sha1
        """
        return self._sha1

    @sha1.setter
    def sha1(self, sha1):
        """Sets the sha1 of this ProcedureInfoListInner.


        :param sha1: The sha1 of this ProcedureInfoListInner.  # noqa: E501
        :type: Sha1
        """

        self._sha1 = sha1

    @property
    def sha256(self):
        """Gets the sha256 of this ProcedureInfoListInner.  # noqa: E501


        :return: The sha256 of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Sha256
        """
        return self._sha256

    @sha256.setter
    def sha256(self, sha256):
        """Sets the sha256 of this ProcedureInfoListInner.


        :param sha256: The sha256 of this ProcedureInfoListInner.  # noqa: E501
        :type: Sha256
        """

        self._sha256 = sha256

    @property
    def sha512(self):
        """Gets the sha512 of this ProcedureInfoListInner.  # noqa: E501


        :return: The sha512 of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Sha512
        """
        return self._sha512

    @sha512.setter
    def sha512(self, sha512):
        """Sets the sha512 of this ProcedureInfoListInner.


        :param sha512: The sha512 of this ProcedureInfoListInner.  # noqa: E501
        :type: Sha512
        """

        self._sha512 = sha512

    @property
    def md5(self):
        """Gets the md5 of this ProcedureInfoListInner.  # noqa: E501


        :return: The md5 of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Md5
        """
        return self._md5

    @md5.setter
    def md5(self, md5):
        """Sets the md5 of this ProcedureInfoListInner.


        :param md5: The md5 of this ProcedureInfoListInner.  # noqa: E501
        :type: Md5
        """

        self._md5 = md5

    @property
    def object_class(self):
        """Gets the object_class of this ProcedureInfoListInner.  # noqa: E501


        :return: The object_class of this ProcedureInfoListInner.  # noqa: E501
        :rtype: ObjectClass
        """
        return self._object_class

    @object_class.setter
    def object_class(self, object_class):
        """Sets the object_class of this ProcedureInfoListInner.


        :param object_class: The object_class of this ProcedureInfoListInner.  # noqa: E501
        :type: ObjectClass
        """

        self._object_class = object_class

    @property
    def unix_filetype(self):
        """Gets the unix_filetype of this ProcedureInfoListInner.  # noqa: E501


        :return: The unix_filetype of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Filetype
        """
        return self._unix_filetype

    @unix_filetype.setter
    def unix_filetype(self, unix_filetype):
        """Sets the unix_filetype of this ProcedureInfoListInner.


        :param unix_filetype: The unix_filetype of this ProcedureInfoListInner.  # noqa: E501
        :type: Filetype
        """

        self._unix_filetype = unix_filetype

    @property
    def upload_date(self):
        """Gets the upload_date of this ProcedureInfoListInner.  # noqa: E501


        :return: The upload_date of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Timestamp
        """
        return self._upload_date

    @upload_date.setter
    def upload_date(self, upload_date):
        """Sets the upload_date of this ProcedureInfoListInner.


        :param upload_date: The upload_date of this ProcedureInfoListInner.  # noqa: E501
        :type: Timestamp
        """

        self._upload_date = upload_date

    @property
    def filenames(self):
        """Gets the filenames of this ProcedureInfoListInner.  # noqa: E501


        :return: The filenames of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Filenames
        """
        return self._filenames

    @filenames.setter
    def filenames(self, filenames):
        """Sets the filenames of this ProcedureInfoListInner.


        :param filenames: The filenames of this ProcedureInfoListInner.  # noqa: E501
        :type: Filenames
        """

        self._filenames = filenames

    @property
    def tags(self):
        """Gets the tags of this ProcedureInfoListInner.  # noqa: E501


        :return: The tags of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Tags
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this ProcedureInfoListInner.


        :param tags: The tags of this ProcedureInfoListInner.  # noqa: E501
        :type: Tags
        """

        self._tags = tags

    @property
    def status(self):
        """Gets the status of this ProcedureInfoListInner.  # noqa: E501


        :return: The status of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Status
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ProcedureInfoListInner.


        :param status: The status of this ProcedureInfoListInner.  # noqa: E501
        :type: Status
        """

        self._status = status

    @property
    def analysis(self):
        """Gets the analysis of this ProcedureInfoListInner.  # noqa: E501


        :return: The analysis of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Analysis
        """
        return self._analysis

    @analysis.setter
    def analysis(self, analysis):
        """Sets the analysis of this ProcedureInfoListInner.


        :param analysis: The analysis of this ProcedureInfoListInner.  # noqa: E501
        :type: Analysis
        """

        self._analysis = analysis

    @property
    def is_public(self):
        """Gets the is_public of this ProcedureInfoListInner.  # noqa: E501


        :return: The is_public of this ProcedureInfoListInner.  # noqa: E501
        :rtype: IsPublic
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public):
        """Sets the is_public of this ProcedureInfoListInner.


        :param is_public: The is_public of this ProcedureInfoListInner.  # noqa: E501
        :type: IsPublic
        """

        self._is_public = is_public

    @property
    def is_owned(self):
        """Gets the is_owned of this ProcedureInfoListInner.  # noqa: E501


        :return: The is_owned of this ProcedureInfoListInner.  # noqa: E501
        :rtype: IsOwned
        """
        return self._is_owned

    @is_owned.setter
    def is_owned(self, is_owned):
        """Sets the is_owned of this ProcedureInfoListInner.


        :param is_owned: The is_owned of this ProcedureInfoListInner.  # noqa: E501
        :type: IsOwned
        """

        self._is_owned = is_owned

    @property
    def tokens(self):
        """Gets the tokens of this ProcedureInfoListInner.  # noqa: E501


        :return: The tokens of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Tokens
        """
        return self._tokens

    @tokens.setter
    def tokens(self, tokens):
        """Sets the tokens of this ProcedureInfoListInner.


        :param tokens: The tokens of this ProcedureInfoListInner.  # noqa: E501
        :type: Tokens
        """

        self._tokens = tokens

    @property
    def av_names(self):
        """Gets the av_names of this ProcedureInfoListInner.  # noqa: E501


        :return: The av_names of this ProcedureInfoListInner.  # noqa: E501
        :rtype: AvNames
        """
        return self._av_names

    @av_names.setter
    def av_names(self, av_names):
        """Sets the av_names of this ProcedureInfoListInner.


        :param av_names: The av_names of this ProcedureInfoListInner.  # noqa: E501
        :type: AvNames
        """

        self._av_names = av_names

    @property
    def detection_stats(self):
        """Gets the detection_stats of this ProcedureInfoListInner.  # noqa: E501


        :return: The detection_stats of this ProcedureInfoListInner.  # noqa: E501
        :rtype: DetectionStats
        """
        return self._detection_stats

    @detection_stats.setter
    def detection_stats(self, detection_stats):
        """Sets the detection_stats of this ProcedureInfoListInner.


        :param detection_stats: The detection_stats of this ProcedureInfoListInner.  # noqa: E501
        :type: DetectionStats
        """

        self._detection_stats = detection_stats

    @property
    def labels(self):
        """Gets the labels of this ProcedureInfoListInner.  # noqa: E501


        :return: The labels of this ProcedureInfoListInner.  # noqa: E501
        :rtype: Labels
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this ProcedureInfoListInner.


        :param labels: The labels of this ProcedureInfoListInner.  # noqa: E501
        :type: Labels
        """

        self._labels = labels

    @property
    def start_ea(self):
        """Gets the start_ea of this ProcedureInfoListInner.  # noqa: E501


        :return: The start_ea of this ProcedureInfoListInner.  # noqa: E501
        :rtype: str
        """
        return self._start_ea

    @start_ea.setter
    def start_ea(self, start_ea):
        """Sets the start_ea of this ProcedureInfoListInner.


        :param start_ea: The start_ea of this ProcedureInfoListInner.  # noqa: E501
        :type: str
        """

        self._start_ea = start_ea

    @property
    def end_ea(self):
        """Gets the end_ea of this ProcedureInfoListInner.  # noqa: E501


        :return: The end_ea of this ProcedureInfoListInner.  # noqa: E501
        :rtype: str
        """
        return self._end_ea

    @end_ea.setter
    def end_ea(self, end_ea):
        """Sets the end_ea of this ProcedureInfoListInner.


        :param end_ea: The end_ea of this ProcedureInfoListInner.  # noqa: E501
        :type: str
        """

        self._end_ea = end_ea

    @property
    def procedure_name(self):
        """Gets the procedure_name of this ProcedureInfoListInner.  # noqa: E501


        :return: The procedure_name of this ProcedureInfoListInner.  # noqa: E501
        :rtype: str
        """
        return self._procedure_name

    @procedure_name.setter
    def procedure_name(self, procedure_name):
        """Sets the procedure_name of this ProcedureInfoListInner.


        :param procedure_name: The procedure_name of this ProcedureInfoListInner.  # noqa: E501
        :type: str
        """

        self._procedure_name = procedure_name

    @property
    def procedure_segment(self):
        """Gets the procedure_segment of this ProcedureInfoListInner.  # noqa: E501


        :return: The procedure_segment of this ProcedureInfoListInner.  # noqa: E501
        :rtype: str
        """
        return self._procedure_segment

    @procedure_segment.setter
    def procedure_segment(self, procedure_segment):
        """Sets the procedure_segment of this ProcedureInfoListInner.


        :param procedure_segment: The procedure_segment of this ProcedureInfoListInner.  # noqa: E501
        :type: str
        """

        self._procedure_segment = procedure_segment

    @property
    def strings(self):
        """Gets the strings of this ProcedureInfoListInner.  # noqa: E501


        :return: The strings of this ProcedureInfoListInner.  # noqa: E501
        :rtype: list[str]
        """
        return self._strings

    @strings.setter
    def strings(self, strings):
        """Sets the strings of this ProcedureInfoListInner.


        :param strings: The strings of this ProcedureInfoListInner.  # noqa: E501
        :type: list[str]
        """

        self._strings = strings

    @property
    def api_calls(self):
        """Gets the api_calls of this ProcedureInfoListInner.  # noqa: E501


        :return: The api_calls of this ProcedureInfoListInner.  # noqa: E501
        :rtype: list[str]
        """
        return self._api_calls

    @api_calls.setter
    def api_calls(self, api_calls):
        """Sets the api_calls of this ProcedureInfoListInner.


        :param api_calls: The api_calls of this ProcedureInfoListInner.  # noqa: E501
        :type: list[str]
        """

        self._api_calls = api_calls

    @property
    def blocks(self):
        """Gets the blocks of this ProcedureInfoListInner.  # noqa: E501


        :return: The blocks of this ProcedureInfoListInner.  # noqa: E501
        :rtype: ProcedureInfoListInnerBlocks
        """
        return self._blocks

    @blocks.setter
    def blocks(self, blocks):
        """Sets the blocks of this ProcedureInfoListInner.


        :param blocks: The blocks of this ProcedureInfoListInner.  # noqa: E501
        :type: ProcedureInfoListInnerBlocks
        """

        self._blocks = blocks

    @property
    def block_count(self):
        """Gets the block_count of this ProcedureInfoListInner.  # noqa: E501


        :return: The block_count of this ProcedureInfoListInner.  # noqa: E501
        :rtype: int
        """
        return self._block_count

    @block_count.setter
    def block_count(self, block_count):
        """Sets the block_count of this ProcedureInfoListInner.


        :param block_count: The block_count of this ProcedureInfoListInner.  # noqa: E501
        :type: int
        """

        self._block_count = block_count

    @property
    def code_count(self):
        """Gets the code_count of this ProcedureInfoListInner.  # noqa: E501


        :return: The code_count of this ProcedureInfoListInner.  # noqa: E501
        :rtype: int
        """
        return self._code_count

    @code_count.setter
    def code_count(self, code_count):
        """Sets the code_count of this ProcedureInfoListInner.


        :param code_count: The code_count of this ProcedureInfoListInner.  # noqa: E501
        :type: int
        """

        self._code_count = code_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProcedureInfoListInner, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcedureInfoListInner):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
