# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ProcedureSignatures(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'used_binaries': 'list[Sha1]',
        'filtered_binaries': 'list[Sha1]',
        'procedures': 'list[ProcedureSignature]'
    }

    attribute_map = {
        'used_binaries': 'used_binaries',
        'filtered_binaries': 'filtered_binaries',
        'procedures': 'procedures'
    }

    def __init__(self, used_binaries=None, filtered_binaries=None, procedures=None):  # noqa: E501
        """ProcedureSignatures - a model defined in Swagger"""  # noqa: E501

        self._used_binaries = None
        self._filtered_binaries = None
        self._procedures = None
        self.discriminator = None

        if used_binaries is not None:
            self.used_binaries = used_binaries
        if filtered_binaries is not None:
            self.filtered_binaries = filtered_binaries
        if procedures is not None:
            self.procedures = procedures

    @property
    def used_binaries(self):
        """Gets the used_binaries of this ProcedureSignatures.  # noqa: E501

        List of binaries used to generate the signatures.  # noqa: E501

        :return: The used_binaries of this ProcedureSignatures.  # noqa: E501
        :rtype: list[Sha1]
        """
        return self._used_binaries

    @used_binaries.setter
    def used_binaries(self, used_binaries):
        """Sets the used_binaries of this ProcedureSignatures.

        List of binaries used to generate the signatures.  # noqa: E501

        :param used_binaries: The used_binaries of this ProcedureSignatures.  # noqa: E501
        :type: list[Sha1]
        """

        self._used_binaries = used_binaries

    @property
    def filtered_binaries(self):
        """Gets the filtered_binaries of this ProcedureSignatures.  # noqa: E501

        List of binaries that the user attempted to use, but doesn't have access to  # noqa: E501

        :return: The filtered_binaries of this ProcedureSignatures.  # noqa: E501
        :rtype: list[Sha1]
        """
        return self._filtered_binaries

    @filtered_binaries.setter
    def filtered_binaries(self, filtered_binaries):
        """Sets the filtered_binaries of this ProcedureSignatures.

        List of binaries that the user attempted to use, but doesn't have access to  # noqa: E501

        :param filtered_binaries: The filtered_binaries of this ProcedureSignatures.  # noqa: E501
        :type: list[Sha1]
        """

        self._filtered_binaries = filtered_binaries

    @property
    def procedures(self):
        """Gets the procedures of this ProcedureSignatures.  # noqa: E501

        List of procedure signatures  # noqa: E501

        :return: The procedures of this ProcedureSignatures.  # noqa: E501
        :rtype: list[ProcedureSignature]
        """
        return self._procedures

    @procedures.setter
    def procedures(self, procedures):
        """Sets the procedures of this ProcedureSignatures.

        List of procedure signatures  # noqa: E501

        :param procedures: The procedures of this ProcedureSignatures.  # noqa: E501
        :type: list[ProcedureSignature]
        """

        self._procedures = procedures

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProcedureSignatures, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcedureSignatures):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
